import { CognitoIdentityServiceProvider } from "aws-sdk";
export declare const clientID = "104m4anpa00b724preu1dco9vj";
export declare const cognito: CognitoIdentityServiceProvider;
export declare type AuthTokens = {
    accessToken: string;
    refreshToken: string;
    idToken: string;
};
export declare type UserInfo = {
    username: string;
    password?: string;
    tokens?: AuthTokens;
};
export declare function tryGetUserInfo(): Promise<UserInfo | undefined>;
export declare function getUserInfo(): Promise<UserInfo>;
export declare function setUserInfo(info: UserInfo): Promise<void>;
export declare function authenticate(username: string, flow: string, parameters: CognitoIdentityServiceProvider.AuthParametersType, refreshToken?: string): Promise<AuthTokens>;
export declare function getIDToken(): Promise<string>;
