"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var os_1 = require("os");
var path = require("path");
var storage = require("node-persist");
var jsonwebtoken_1 = require("jsonwebtoken");
var aws_sdk_1 = require("aws-sdk");
var rot47 = require("caesar-salad").ROT47.Decipher();
var cognitoAccessKeyID = rot47.crypt("pzxpxd#xt*'&ts{q|(}\"");
var cognitoSecretAccessKey = rot47.crypt("xAC%<Gt;!)G+{:9s)Df*K23Hx@H:{'<:Z>+tKFe*");
exports.clientID = "104m4anpa00b724preu1dco9vj";
exports.cognito = new aws_sdk_1.CognitoIdentityServiceProvider({
    region: "us-east-2",
    accessKeyId: cognitoAccessKeyID,
    secretAccessKey: cognitoSecretAccessKey
});
var storageInited = false;
function initStorage() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (storageInited)
                        return [2];
                    return [4, storage.init({ dir: path.join(os_1.homedir(), ".autotune") })];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    });
}
var userInfoKey = "userInfo";
function tryGetUserInfo() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, initStorage()];
                case 1:
                    _a.sent();
                    return [4, storage.getItem(userInfoKey)];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
exports.tryGetUserInfo = tryGetUserInfo;
function getUserInfo() {
    return __awaiter(this, void 0, void 0, function () {
        var userInfo;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, tryGetUserInfo()];
                case 1:
                    userInfo = _a.sent();
                    if (userInfo === undefined) {
                        console.error('You\'re not logged in :-(.  Please use "login" to log in');
                        console.error('or "signup" to sign up, if you haven\'t done so already.');
                        return [2, process.exit(1)];
                    }
                    return [2, userInfo];
            }
        });
    });
}
exports.getUserInfo = getUserInfo;
function setUserInfo(info) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, initStorage()];
                case 1:
                    _a.sent();
                    return [4, storage.setItem(userInfoKey, info)];
                case 2:
                    _a.sent();
                    return [2];
            }
        });
    });
}
exports.setUserInfo = setUserInfo;
function authenticate(username, flow, parameters, refreshToken) {
    return __awaiter(this, void 0, void 0, function () {
        var response, tokens;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, exports.cognito
                        .initiateAuth({
                        ClientId: exports.clientID,
                        AuthFlow: flow,
                        AuthParameters: parameters
                    })
                        .promise()];
                case 1:
                    response = _a.sent();
                    if (response.AuthenticationResult === undefined ||
                        typeof response.AuthenticationResult.AccessToken !== "string" ||
                        typeof response.AuthenticationResult.IdToken !== "string" ||
                        (refreshToken === undefined && typeof response.AuthenticationResult.RefreshToken !== "string")) {
                        throw new Error("Could not authenticate: " + JSON.stringify(response));
                    }
                    if (refreshToken === undefined) {
                        refreshToken = response.AuthenticationResult.RefreshToken;
                    }
                    tokens = {
                        accessToken: response.AuthenticationResult.AccessToken,
                        refreshToken: refreshToken,
                        idToken: response.AuthenticationResult.IdToken
                    };
                    return [4, setUserInfo({ username: username, tokens: tokens })];
                case 2:
                    _a.sent();
                    return [2, tokens];
            }
        });
    });
}
exports.authenticate = authenticate;
function getIDToken() {
    return __awaiter(this, void 0, void 0, function () {
        var userInfo, tokens, decodedToken;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getUserInfo()];
                case 1:
                    userInfo = _a.sent();
                    tokens = userInfo.tokens;
                    if (tokens === undefined) {
                        console.error("Please log in and confirm your account first");
                        return [2, process.exit(1)];
                    }
                    decodedToken = jsonwebtoken_1.decode(tokens.idToken);
                    if (!(typeof decodedToken === "object" && decodedToken !== null && typeof decodedToken.exp === "number")) return [3, 3];
                    if (!(decodedToken.exp <= Date.now() / 1000 + 5)) return [3, 3];
                    return [4, authenticate(userInfo.username, "REFRESH_TOKEN_AUTH", {
                            REFRESH_TOKEN: tokens.refreshToken
                        }, tokens.refreshToken)];
                case 2:
                    tokens = _a.sent();
                    _a.label = 3;
                case 3: return [2, tokens.idToken];
            }
        });
    });
}
exports.getIDToken = getIDToken;
//# sourceMappingURL=Authentication.js.map