#!/usr/bin/env node
"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var fs = require("fs");
var request = require("request-promise-native");
var yargs = require("yargs");
var updateNotifier = require("update-notifier");
var ClientAPI_1 = require("../schemas/ClientAPI");
var chalk_1 = require("chalk");
var table_1 = require("table");
var moment = require("moment");
var Authentication_1 = require("./Authentication");
var DecisionTree_1 = require("../client/DecisionTree");
var treeify = require("treeify");
var red = chalk_1["default"].red, yellow = chalk_1["default"].yellow, blue = chalk_1["default"].blue, magenta = chalk_1["default"].magenta, cyan = chalk_1["default"].cyan, dim = chalk_1["default"].dim, bold = chalk_1["default"].bold;
var star = yellow("★");
function cmdSignup(_args, email, password) {
    return __awaiter(this, void 0, void 0, function () {
        var response, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4, Authentication_1.cognito
                            .signUp({
                            ClientId: Authentication_1.clientID,
                            Username: email,
                            Password: password,
                            UserAttributes: [{ Name: "email", Value: email }]
                        })
                            .promise()];
                case 1:
                    response = _a.sent();
                    return [3, 3];
                case 2:
                    e_1 = _a.sent();
                    if (e_1.code === "UsernameExistsException") {
                        console.error("An account already exists for " + email);
                    }
                    else {
                        console.error("Could not sign up: " + e_1.message);
                    }
                    return [2];
                case 3:
                    if (response.UserConfirmed) {
                        console.log("User creation confirmed");
                    }
                    else {
                        console.log("Confirmation code sent to " + response.CodeDeliveryDetails.Destination);
                        console.log('Please use the "confirm" command with the code');
                    }
                    return [4, Authentication_1.setUserInfo({ username: email, password: password })];
                case 4:
                    _a.sent();
                    return [2];
            }
        });
    });
}
function createDemoApp() {
    return __awaiter(this, void 0, void 0, function () {
        var appKey;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, createApp("My sample autotune app")];
                case 1:
                    appKey = _a.sent();
                    console.log("");
                    console.log("We've created a sample app for you to start with! Add this script tag:");
                    console.log("");
                    console.log("  <script src=\"" + ClientAPI_1.clientUrl(appKey) + "\"></script>");
                    console.log("");
                    console.log("Then create an experiment:");
                    console.log("");
                    console.log("  <autotune>");
                    console.log("    <h1>The glass is half full</h1>");
                    console.log("    <h1>The glass is half empty</h1>");
                    console.log("  </autotune>");
                    console.log("");
                    console.log("Finally, add the autotune attribute to links that you want users to click:");
                    console.log("");
                    console.log("  <a href=\"/buy\" autotune>Buy now</a>");
                    console.log("");
                    return [2];
            }
        });
    });
}
function cmdConfirm(_args, email, code) {
    return __awaiter(this, void 0, void 0, function () {
        var password, userInfo;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    password = undefined;
                    if (!(email === undefined)) return [3, 2];
                    return [4, Authentication_1.getUserInfo()];
                case 1:
                    userInfo = _a.sent();
                    email = userInfo.username;
                    password = userInfo.password;
                    _a.label = 2;
                case 2: return [4, Authentication_1.cognito
                        .confirmSignUp({
                        ClientId: Authentication_1.clientID,
                        Username: email,
                        ConfirmationCode: code
                    })
                        .promise()];
                case 3:
                    _a.sent();
                    console.log("User creation confirmed");
                    if (!(password !== undefined)) return [3, 6];
                    return [4, authenticateWithPassword(email, password)];
                case 4:
                    _a.sent();
                    return [4, createDemoApp()];
                case 5:
                    _a.sent();
                    return [3, 7];
                case 6:
                    console.log("Please login to start using autotune");
                    _a.label = 7;
                case 7: return [2];
            }
        });
    });
}
function authenticateWithPassword(email, password) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, Authentication_1.authenticate(email, "USER_PASSWORD_AUTH", {
                        USERNAME: email,
                        PASSWORD: password
                    })];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    });
}
function cmdLogin(_args, email, password) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, authenticateWithPassword(email, password)];
                case 1:
                    _a.sent();
                    console.log("You're now logged in.");
                    return [2];
            }
        });
    });
}
function makeAuthHeaders() {
    return __awaiter(this, void 0, void 0, function () {
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = {
                        "Cache-Control": "no-cache",
                        "Content-Type": "application/json"
                    };
                    return [4, Authentication_1.getIDToken()];
                case 1: return [2, (_a.Authorization = _b.sent(),
                        _a)];
            }
        });
    });
}
function requestWithAuth(endpoint, body) {
    return __awaiter(this, void 0, void 0, function () {
        var url, requestOptions, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (endpoint.startsWith("https://")) {
                        url = endpoint;
                    }
                    else {
                        url = "https://2vyiuehl9j.execute-api.us-east-2.amazonaws.com/prod/" + endpoint;
                    }
                    _a = {
                        method: "POST",
                        url: url
                    };
                    return [4, makeAuthHeaders()];
                case 1:
                    requestOptions = (_a.headers = _b.sent(),
                        _a.body = body,
                        _a.json = true,
                        _a);
                    return [4, request(requestOptions).promise()];
                case 2: return [2, _b.sent()];
            }
        });
    });
}
function createApp(name) {
    return __awaiter(this, void 0, void 0, function () {
        var body, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    body = { name: name };
                    return [4, requestWithAuth("createAppKey", body)];
                case 1:
                    result = _a.sent();
                    return [2, result.appKey];
            }
        });
    });
}
function cmdCreateApp(_args, name) {
    return __awaiter(this, void 0, void 0, function () {
        var appKey;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, createApp(name)];
                case 1:
                    appKey = _a.sent();
                    console.log("\u2713 Created app '" + magenta(name) + "' with key " + bold(appKey));
                    console.log();
                    console.log("Add this code to your web page:");
                    console.log();
                    console.log([blue("<script"), " ", yellow("src"), blue("="), red("\"" + ClientAPI_1.clientUrl(appKey) + "\""), blue("></script>")].join(""));
                    return [2];
            }
        });
    });
}
var graphQLQueryAll = "query {\n    viewer {\n        username\n        applications {\n            name\n            key\n            experiments {\n                name\n                started\n                options {\n                    name\n                    completed\n                    payoff\n                }\n            }\n        }\n    }\n}";
var graphQLQueryApplication = "query($key: String!) {\n    getApplication(key: $key) {\n        name\n        key\n        experiments {\n            name\n            started\n            options {\n                name\n                completed\n                payoff\n            }\n        }\n    }\n}";
function queryGraphQL(query, queryName, variables) {
    return __awaiter(this, void 0, void 0, function () {
        var body, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    body = { query: query, variables: variables };
                    return [4, requestWithAuth("https://wnzihyd3zndg3i3zdo6ijwslze.appsync-api.us-west-2.amazonaws.com/graphql", body)];
                case 1:
                    result = _a.sent();
                    if (result.errors !== undefined) {
                        throw new Error("Errors from server: " + JSON.stringify(result));
                    }
                    if (result.data === null) {
                        throw new Error("No data returned from server");
                    }
                    return [2, result.data[queryName]];
            }
        });
    });
}
function getApp(keyOrName) {
    return __awaiter(this, void 0, void 0, function () {
        var isUUID, app, user;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    isUUID = /^[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/i.test(keyOrName);
                    if (!isUUID) return [3, 2];
                    return [4, queryGraphQL(graphQLQueryApplication, "getApplication", {
                            key: keyOrName
                        })];
                case 1:
                    app = _a.sent();
                    if (app !== null)
                        return [2, app];
                    _a.label = 2;
                case 2: return [4, queryGraphQL(graphQLQueryAll, "viewer")];
                case 3:
                    user = _a.sent();
                    return [2, user.applications.find(function (a) { return a.name === keyOrName; })];
            }
        });
    });
}
function listApps(_args) {
    return __awaiter(this, void 0, void 0, function () {
        var user, apps;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, queryGraphQL(graphQLQueryAll, "viewer")];
                case 1:
                    user = _a.sent();
                    apps = user.applications
                        .sort(function (a, b) { return a.name.localeCompare(b.name); })
                        .map(function (app) { return [magenta(app.name), app.key]; });
                    logTable([[bold("App Name"), bold("Key")]].concat(apps));
                    return [2];
            }
        });
    });
}
function cmdListExperiments(_args, appKey) {
    return __awaiter(this, void 0, void 0, function () {
        var app, _i, _a, experiment, rows, ago, options, first, _b, options_1, o, conversionRate, conversion, name_1;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4, getApp(appKey)];
                case 1:
                    app = _c.sent();
                    if (app === undefined) {
                        throw new Error("Application not found");
                    }
                    if (app.experiments.length === 0) {
                        console.log("Experiments for app not found. Data is processed in batches and may take a while to be ready. Please try again later.");
                        return [2];
                    }
                    for (_i = 0, _a = app.experiments; _i < _a.length; _i++) {
                        experiment = _a[_i];
                        rows = [];
                        ago = moment(experiment.started).fromNow();
                        rows.push([bold(magenta(experiment.name)), "Since " + ago, "Conversion"]);
                        options = experiment.options
                            .map(function (o) { return (__assign({}, o, { result: o.payoff / o.completed })); })
                            .sort(function (a, b) { return b.result - a.result; });
                        first = true;
                        for (_b = 0, options_1 = options; _b < options_1.length; _b++) {
                            o = options_1[_b];
                            conversionRate = (Math.floor(o.result * 1000) / 10).toString();
                            conversion = first ? bold(conversionRate) : conversionRate;
                            name_1 = first ? bold(o.name + " " + star) : o.name;
                            rows.push([name_1, dim(o.completed + " instances"), conversion + "%"]);
                            first = false;
                        }
                        logTable(rows);
                    }
                    return [2];
            }
        });
    });
}
function makePrintTree(outcome) {
    var options = outcome.options;
    function convert(t) {
        if (t.best !== undefined) {
            return bold(options[t.best]) + " - epsilon: " + t.eps;
        }
        var _a = t.op === "lt" ? { op: "<", neg: ">=" } : { op: "=", neg: "!=" }, op = _a.op, neg = _a.neg;
        var result = {};
        result[t.at + " " + op + " " + t.v] = convert(t.l);
        result[t.at + " " + neg + " " + t.v] = convert(t.r);
        return result;
    }
    return convert(outcome.tree);
}
function getOutcomesForApp(app) {
    return __awaiter(this, void 0, void 0, function () {
        var requestOptions;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    requestOptions = {
                        method: "GET",
                        url: ClientAPI_1.outcomesUrl(app.key),
                        json: true
                    };
                    return [4, request(requestOptions).promise()];
                case 1: return [2, _a.sent()];
            }
        });
    });
}
function getOutcomesForAppKeyOrFilename(appKey) {
    return __awaiter(this, void 0, void 0, function () {
        var outcomes, app, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    app = undefined;
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4, getApp(appKey)];
                case 2:
                    app = _b.sent();
                    return [3, 4];
                case 3:
                    _a = _b.sent();
                    return [3, 4];
                case 4:
                    if (!(app !== undefined)) return [3, 6];
                    return [4, getOutcomesForApp(app)];
                case 5:
                    outcomes = _b.sent();
                    return [3, 7];
                case 6:
                    if (fs.existsSync(appKey)) {
                        outcomes = JSON.parse(fs.readFileSync(appKey, "utf-8"));
                    }
                    else {
                        throw new Error("Application not found");
                    }
                    _b.label = 7;
                case 7: return [2, outcomes];
            }
        });
    });
}
function cmdShowTrees(appKey) {
    return __awaiter(this, void 0, void 0, function () {
        var outcomes, _i, _a, experimentKey;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4, getOutcomesForAppKeyOrFilename(appKey)];
                case 1:
                    outcomes = _b.sent();
                    for (_i = 0, _a = Object.getOwnPropertyNames(outcomes); _i < _a.length; _i++) {
                        experimentKey = _a[_i];
                        console.log(bold(magenta(experimentKey)));
                        console.log(treeify.asTree(makePrintTree(outcomes[experimentKey]), true));
                    }
                    return [2];
            }
        });
    });
}
function relativePayoffForCount(c) {
    return c.payoff / c.completed;
}
function makeAppStatistics(outcomes, counts) {
    var countsByPick = {};
    for (var _i = 0, _a = Object.getOwnPropertyNames(counts); _i < _a.length; _i++) {
        var experiment = _a[_i];
        var outcome = outcomes[experiment];
        if (outcome === undefined)
            continue;
        var cts = counts[experiment];
        var optionNames = new Set();
        for (var _b = 0, _c = cts.data; _b < _c.length; _b++) {
            var d = _c[_b];
            for (var _d = 0, _e = Object.getOwnPropertyNames(d.counts); _d < _e.length; _d++) {
                var option = _e[_d];
                optionNames.add(option);
            }
        }
        countsByPick[experiment] = {};
        var _loop_1 = function (d) {
            var pick = DecisionTree_1.lookupBestOption(d.clientContext, outcome).option;
            if (pick === undefined) {
                console.log("no best option found");
                return "continue";
            }
            var c = countsByPick[experiment][pick];
            if (c === undefined) {
                c = { best: { completed: 0, payoff: 0 }, others: {} };
                countsByPick[experiment][pick] = c;
            }
            var othersCount = function (option) {
                if (c.others[option] === undefined) {
                    c.others[option] = { completed: 0, payoff: 0 };
                }
                return c.others[option];
            };
            var pickCounts = d.counts[pick];
            if (pickCounts === undefined || pickCounts === null) {
                var keys = Object.getOwnPropertyNames(d.counts);
                var totalPayoff = 0;
                for (var _i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
                    var k = keys_1[_i];
                    var ck = d.counts[k];
                    if (ck === null)
                        continue;
                    totalPayoff += ck.payoff;
                }
                if (totalPayoff === 0) {
                    return "continue";
                }
                return "continue";
            }
            var relativePayoffForPick = relativePayoffForCount(pickCounts);
            c.best.completed += pickCounts.completed;
            c.best.payoff += pickCounts.payoff;
            var optionsSet = new Set();
            var minPayoff = relativePayoffForPick;
            for (var _a = 0, _b = Object.getOwnPropertyNames(d.counts); _a < _b.length; _a++) {
                var option = _b[_a];
                var countsForOption = d.counts[option];
                if (countsForOption === null)
                    continue;
                optionsSet.add(option);
                var relativePayoff = relativePayoffForCount(countsForOption);
                if (option === pick) {
                    continue;
                }
                var oc = othersCount(option);
                oc.completed += pickCounts.completed;
                oc.payoff += relativePayoff * pickCounts.completed;
                if (relativePayoff < minPayoff) {
                    minPayoff = relativePayoff;
                }
            }
            for (var _c = 0, _d = Array.from(optionNames); _c < _d.length; _c++) {
                var option = _d[_c];
                if (optionsSet.has(option) || option === pick) {
                    continue;
                }
                var oc = othersCount(option);
                oc.completed += pickCounts.completed;
                oc.payoff += minPayoff * pickCounts.completed;
            }
        };
        for (var _f = 0, _g = cts.data; _f < _g.length; _f++) {
            var d = _g[_f];
            _loop_1(d);
        }
    }
    var appStatistics = { experiments: {} };
    for (var _h = 0, _j = Object.getOwnPropertyNames(countsByPick); _h < _j.length; _h++) {
        var experiment = _j[_h];
        var stats = [];
        var totalCompleted = 0;
        for (var _k = 0, _l = Object.getOwnPropertyNames(countsByPick[experiment]); _k < _l.length; _k++) {
            var pick = _l[_k];
            totalCompleted += countsByPick[experiment][pick].best.completed;
        }
        for (var _m = 0, _o = Object.getOwnPropertyNames(countsByPick[experiment]); _m < _o.length; _m++) {
            var pick = _o[_m];
            var cts = countsByPick[experiment][pick];
            var alternatives = [];
            for (var _p = 0, _q = Object.getOwnPropertyNames(cts.others); _p < _q.length; _p++) {
                var option = _q[_p];
                var otherCount = cts.others[option];
                if (otherCount.completed !== cts.best.completed) {
                    throw new Error("we counted completed incorrectly");
                }
                alternatives.push({ option: option, payoff: relativePayoffForCount(otherCount) });
            }
            alternatives.sort(function (a, b) { return b.payoff - a.payoff; });
            var audience = cts.best.completed / totalCompleted;
            var payoff = relativePayoffForCount(cts.best);
            stats.push({ pick: pick, audience: audience, payoff: payoff, alternatives: alternatives });
        }
        stats.sort(function (a, b) { return b.audience - a.audience; });
        appStatistics.experiments[experiment] = stats;
    }
    return appStatistics;
}
function formatPercentage(p, decimalPlaces) {
    return (p * 100).toFixed(decimalPlaces) + "%";
}
function getCountsForApp(app) {
    return __awaiter(this, void 0, void 0, function () {
        var body, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    body = { appKey: app.key };
                    return [4, requestWithAuth("getCounts", body)];
                case 1:
                    result = _a.sent();
                    return [2, result];
            }
        });
    });
}
function cmdShowStats(appKey, alternatives) {
    return __awaiter(this, void 0, void 0, function () {
        var app, outcomes, counts, stats, _i, _a, experiment, rows, _b, _c, pickStat, _d, _e, altStat;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0: return [4, getApp(appKey)];
                case 1:
                    app = _f.sent();
                    if (app === undefined) {
                        throw new Error("App " + appKey + " does not exist");
                    }
                    return [4, getOutcomesForApp(app)];
                case 2:
                    outcomes = _f.sent();
                    return [4, getCountsForApp(app)];
                case 3:
                    counts = _f.sent();
                    stats = makeAppStatistics(outcomes, counts);
                    for (_i = 0, _a = Object.getOwnPropertyNames(stats.experiments); _i < _a.length; _i++) {
                        experiment = _a[_i];
                        rows = [[bold("Option"), bold("Audience"), bold("Payoff")]];
                        for (_b = 0, _c = stats.experiments[experiment]; _b < _c.length; _b++) {
                            pickStat = _c[_b];
                            rows.push([
                                bold(pickStat.pick + " " + star),
                                formatPercentage(pickStat.audience, 2),
                                formatPercentage(pickStat.payoff, 2)
                            ]);
                            if (!alternatives) {
                                continue;
                            }
                            for (_d = 0, _e = pickStat.alternatives; _d < _e.length; _d++) {
                                altStat = _e[_d];
                                rows.push([altStat.option, "", formatPercentage(altStat.payoff, 2)]);
                            }
                        }
                        console.log(bold(magenta(experiment)));
                        logTable(rows);
                    }
                    return [2];
            }
        });
    });
}
function graphQL(_args) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, _b, _c, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    _b = (_a = console).log;
                    _d = (_c = JSON).stringify;
                    return [4, queryGraphQL(graphQLQueryAll, "viewer")];
                case 1:
                    _b.apply(_a, [_d.apply(_c, [_e.sent(), undefined, 4])]);
                    return [2];
            }
        });
    });
}
function notifyIfCLIUpdatesAvailable() {
    try {
        var pkg = require("../../package.json");
        var notifier = updateNotifier({ pkg: pkg });
        notifier.notify();
    }
    catch (e) { }
}
function main() {
    return __awaiter(this, void 0, void 0, function () {
        function cmd(p) {
            p["catch"](function (e) {
                console.error(e);
                process.exit(1);
            });
            didSomething = true;
        }
        var didSomething, argv;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    didSomething = false;
                    argv = yargs
                        .usage("Usage: " + cyan("$0") + " <command> " + dim("[options]"))
                        .command("signup <email> <password>", dim("Create a new account"), function (ya) { return ya.positional("email", { type: "string" }).positional("password", { type: "string" }); }, function (args) { return cmd(cmdSignup(args, args.email, args.password)); })
                        .command("confirm <code>", dim("Confirm a new account"), function (ya) { return ya.positional("email", { type: "string" }).positional("code", { type: "string" }); }, function (args) { return cmd(cmdConfirm(args, args.email, args.code)); })
                        .command("login <email> <password>", dim("Login"), function (ya) { return ya.positional("email", { type: "string" }).positional("password", { type: "string" }); }, function (args) { return cmd(cmdLogin(args, args.email, args.password)); })
                        .command("new <name>", dim("Create a new app"), function (ya) { return ya.positional("name", { type: "string" }); }, function (args) { return cmd(cmdCreateApp(args, args.name)); })
                        .command("ls [key|name]", dim("List apps or experiments for an app"), function (ya) { return ya.positional("key", { type: "string" }); }, function (args) {
                        if (args.key !== undefined) {
                            cmd(cmdListExperiments(args, args.key));
                        }
                        else {
                            cmd(listApps(args));
                        }
                    })
                        .command("trees <key|name|filename>", dim("Show decision trees for experiments in an app"), function (ya) { return ya.positional("key", { type: "string" }); }, function (args) { return cmd(cmdShowTrees(args.key)); })
                        .command("stats [--alternatives] <key|name>", dim("Show statistics"), function (ya) { return ya.positional("key", { type: "string" }).boolean("alternatives"); }, function (args) { return cmd(cmdShowStats(args.key, args.alternatives)); })
                        .command("graphql", false, {}, function (args) { return cmd(graphQL(args)); })
                        .wrap(yargs.terminalWidth()).argv;
                    if (!(!didSomething || argv.help)) return [3, 2];
                    return [4, Authentication_1.tryGetUserInfo()];
                case 1:
                    if ((_a.sent()) === undefined) {
                        console.error("You're not logged in to autotune.");
                        console.error("");
                        console.error("  Create account: tune signup EMAIL PASSWORD");
                        console.error("  Log in:         tune login EMAIL PASSWORD");
                        console.error("");
                    }
                    yargs.showHelp();
                    _a.label = 2;
                case 2:
                    notifyIfCLIUpdatesAvailable();
                    return [2];
            }
        });
    });
}
function removeWhitespace(data) {
    if (Array.isArray(data)) {
        return data.map(removeWhitespace);
    }
    if (typeof data === "string") {
        return data.replace(/\s+/g, " ").trim();
    }
    return data;
}
function logTable(rows, style) {
    if (style === void 0) { style = "norc"; }
    rows = removeWhitespace(rows);
    console.log(table_1.table(rows, {
        border: table_1.getBorderCharacters(style),
        columnDefault: {
            truncate: 80
        }
    }));
}
main()["catch"](function (e) { return console.error(e); });
//# sourceMappingURL=index.js.map
