"use strict";
exports.__esModule = true;
function lookupBestOption(ctx, outcome) {
    if (outcome === undefined) {
        return {};
    }
    var options = outcome.options;
    function find(t) {
        if (t.best !== undefined) {
            return { option: options[t.best], epsilon: t.eps };
        }
        if (t.at === undefined || t.op === undefined || t.v === undefined) {
            return {};
        }
        var ctxV = ctx[t.at];
        if (typeof t.v === "string") {
            if (typeof ctxV !== "string")
                ctxV = "null";
        }
        else {
            if (typeof ctxV !== "number")
                ctxV = 0;
        }
        var result;
        switch (t.op) {
            case "lt":
                result = ctxV < t.v;
                break;
            case "eq":
                result = ctxV === t.v;
                break;
            default:
                return {};
        }
        var branch = result ? t.l : t.r;
        if (branch === undefined)
            return {};
        return find(branch);
    }
    return find(outcome.tree);
}
exports.lookupBestOption = lookupBestOption;
//# sourceMappingURL=DecisionTree.js.map