export interface ClientContext {
    [key: string]: string | number;
}
export interface StartExperimentsRequest {
    appKey: string;
    version: 2;
    experiments: {
        [name: string]: {
            instanceKey?: string;
            options: string[];
            pick: string;
            pickedBest: boolean;
        };
    };
    ctx?: ClientContext;
}
export interface StartExperimentsResultForExperiment {
    key: string;
}
export interface StartExperimentsResponse {
    experiments: {
        [name: string]: StartExperimentsResultForExperiment;
    };
}
export interface CompleteExperimentsRequest {
    appKey: string;
    experiments: {
        [instanceKey: string]: {
            pick: string;
            payoff: number;
        };
    };
}
export interface CompleteExperimentsResponse {
}
export declare function s3Url(path: string): string;
export declare function outcomesUrl(appKey: string): string;
export declare function clientUrl(appKey: string): string;
export declare const startExperimentsURL: string;
export declare const completeExperimentsURL: string;
